/*
///////////////////////////////////////////////////////////////////////////////////////////////////
//shnQ hhb(gmTWw QSPU)vO
//	FileName	IIC.c
//	Version		1.00
//	MCU		R8C/25 type:R5F21258,clock:20MHz(XIN clock)
//	Work		
//-------------------------------------------------------------------------------------------------
//

//	2008/06/19	Ver1.00

//-------------------------------------------------------------------------------------------------
//ldln
//	SW1ON,OFFԂ2iEEPROMɏ݂܂B(SW2)
//	񂾒ĺASW3œǂݍ߂܂B
	
	@\:SW,LCD,INT,^C}[RD

//-------------------------------------------------------------------------------------------------
*/

/*

̃\tgEFA̓t[EFAłB

̃\tgEFAɊւ鎿ɂ܂ẮA
T|[g̑ΏۊOƂȂ܂B

쌠͍쐬ł()kldqL̂Ƃ܂B

̃\tgEFAgpƂɂSĂ̑QɂāA
쐬͈؂̐ӔC𕉂Ȃ̂Ƃ܂B

̃\tgEFÄꕔ܂͑SĂ𖳒fœ]ڂ邱Ƃ
֎~܂BGȂǂ֏ЉE^̏ꍇ͘A肢v
܂B

  Copyright (C) Hokuto denshi Co,Ltd. 2008

*/

/*
/////////////////////////////////////////////////////////////////////////////////////////
//CN[ht@C錾

*/
#include "R8C25.h"

/*
/////////////////////////////////////////////////////////////////////////////////////////
//ϐ錾

*/
long msec;						/*҂*/
unsigned int endaddress;				/*[vϐ*/
unsigned char xcursor,ycursor,flag;
unsigned char string[4];				/*SW1̃f[^ۑ*/

/*
/////////////////////////////////////////////////////////////////////////////////////////
//^錾

*/
#define VAL_LCD_ROW	16
#define VAL_LCD_COLUMN	2

/*
/////////////////////////////////////////////////////////////////////////////////////////
//}N錾
*/	
#define LED1	P6.BIT.P_1	/*fobNpLED*/
#define LED2	P6.BIT.P_3
#define LED3	P2.BIT.P_6
#define LED4	P2.BIT.P_4
#define SW1_1	P0.BIT.P_2
#define SW1_2	P3.BIT.P_7
#define SW1_3	P0.BIT.P_0
#define SW1_4	P3.BIT.P_3
#define SW2	P1.BIT.P_7
#define SW3	P4.BIT.P_5
#define DB4	P0.BIT.P_5
#define DB5	P0.BIT.P_7
#define DB6	P0.BIT.P_3
#define DB7	P6.BIT.P_4
#define RS	P6.BIT.P_2
#define E	P0.BIT.P_1


/*
/////////////////////////////////////////////////////////////////////////////////////////
//֐vg^Cv錾
*/
void port_init(void);
void interrupt_init(void);
void byte_write(unsigned int eepromaddress,unsigned char far *writedata,const unsigned char num);
unsigned char byte_read(unsigned int eepromaddress);
unsigned char iic_write(unsigned char writedata);
void read_sw1(void);
void RD_init(void);
void wait(const long sec);
void wait_timer(const long msec2);
void timer_interrupt(void);
void IIC_init(void);
int LCD_init(void);
int LCD_clear(void);
int LCD_write(const char lcddata);
int LCD_location(const unsigned char x,const unsigned char y);
int LCD_print(char far *lcdstr);
void int0_func(void);
void int1_func(void);
void rx_str0(void);

/*
///////////////////////////////////////////////////////////////////////////////
//Main program
*/
void main(void){
	unsigned char far *writebuffer;
	unsigned char far *readbuffer;
	unsigned int i=0;
	xcursor = 0;
	ycursor = 0;
	flag = 0;
	/*NbNݒ*/
	PRCR.BYTE = 0x01;		/*CM0,CM1,OCDɏ*/
	CM1.BIT.CM13 = 1;		/*XIN-XOUT [q*/
	CM0.BIT.CM05 = 0;		/*XINNbNU*/
	asm("NOP");			/*U莞Ԃ҂*/
	asm("NOP");
	asm("NOP");
	asm("NOP");
	OCD.BIT.OCD2 = 0;		/*XINNbNI*/
	
	port_init();
	interrupt_init();
	RD_init();
	asm("MOV.B	#05H,0137H");	/*TRD0 & TRD1̃JEgJn*/
	LCD_init();
	IIC_init();

	endaddress = sizeof (string);	/*f[^̑傫擾*/
	for(i=0; i<endaddress; i++){	/*string*/
		string[i] = '\0';
	}
	
	
	LCD_location(0,0);
	LCD_print("EEPROM with IIC");
	LCD_location(0,1);
	LCD_print("ײ:SW2ذ:SW3");
	while(1){
		if(flag == 2){		/**/
			flag=0;
			LCD_clear();
			read_sw1();
			writebuffer = string;
			for(i=0; i < endaddress; i++){
				writebuffer = string;
				byte_write(i,&(writebuffer[i]),1);/*擪AhXzɓn*/
				wait_timer(10);			/*write cycle time*/
			}
			LCD_location(0,0);
			LCD_print("ײް:");
			LCD_location(8,0);
			LCD_print(writebuffer);
			LCD_location(0,1);
			LCD_print("ݹݦø޻");
			wait_timer(2000);
		}
		
		else if(flag == 3){		/*ǂݍ*/
				flag=0;
				LCD_clear();
				for(i=0; i < endaddress; i++){
					string[i] = byte_read(i);
					wait_timer(10);		/*write cycle time*/
				}
				readbuffer = string;
				LCD_location(0,0);
				LCD_print("ذް:");
				LCD_location(9,0);
				LCD_print(readbuffer);
				LCD_location(0,1);
				LCD_print("ײ:SW2ذ:SW3");
				wait_timer(500);
		}
		wait_timer(500);
	}
}

/*|[g*/
void port_init(void){
	/**********o̓|[g**********/
	PRCR.BIT.PRC2 = 1;		/*PD0ɏ*/
	PD0.BYTE = 0xFA;		/*gpȂs͏o(L)ɐݒ*/
	PD1.BYTE = 0x7F;
	PD2.BYTE = 0xFF;
	PD3.BYTE = 0x33;
	PD4.BYTE = 0xDC;
	PD6.BYTE = 0xFF;
	P0.BYTE = 0x00;
	P1.BYTE = 0x00;
	P2.BYTE = 0x5F;
	P4.BYTE = 0x00;
	P3.BYTE = 0x00;
	P6.BYTE = 0xFF;
}


/**/
void interrupt_init(void){
	/********** ݒ ***********/
	INTEN.BIT.INT0EN = 1;		/*INT0荞݂*/
	INTEN.BIT.INT1EN = 1;		/*INT1荞݂*/
	INTF.BYTE = 0x00;		/*tB^[*/
	#pragma ASM
	FCLR	I			;֎~ ;disable interrupts,I=0
	MOV.B	#01H,005DH		;INT0IC register(SW3)	level 1
	MOV.B	#01H,0059H		;INT1IC register(SW2)	level 1
	FSET	I			;;enable interrupts,I=1
	#pragma ENDASM
}

/*IIC*/
void IIC_init(void){
	/********** IICݒ***********/
	PMR.BIT.IICSEL = 1;		/*IIC oXC^[tF[XI*/
	SAR.BIT.FS = 0;			/*IICoXtH[}bg*/
	if(ICSR.BIT.STOP == 1){		/*STOPrbg0*/
		ICSR.BIT.STOP = 0;
	}
	ICCR1.BIT.ICE = 1;		/*oX쓮*/
	ICMR.BIT.WAIT = 0;		/*EFCgȂ*/
	ICMR.BIT.MLS = 0;		/*MSBI*/
	ICCR1.BYTE = (ICCR1.BYTE | 0x0D);/*NbNݒ f1/200,=100kHz*/
}


/*SW1[h֐*/
/*ON0*/
/*OFF1*/
void read_sw1(void){
	if(SW1_1 == 0){
		string[0] = '1';
	}
	
	else {
		string[0] = '0';
	}
	
	if(SW1_2 == 0){
		string[1] = '1';
	}
	
	else {
		string[1] = '0';
	}
	
	if(SW1_3 == 0){
		string[2] = '1';
	}
	
	else {
		string[2] = '0';
	}
	
	if(SW1_4 == 0){
		string[3] = '1';
	}
	
	else {
		string[3] = '0';
	}
}


void byte_write(unsigned int eepromaddress,unsigned char far *writedata,const unsigned char num){
	unsigned char m,w;
	if(ICSR.BIT.STOP == 1){
		ICSR.BIT.STOP = 0;
	}
	ICCR1.BIT.ICE = 1;

	ICCR1.BYTE = (ICCR1.BYTE | 0x0D);
	ICMR.BIT.WAIT = 0;
	ICMR.BIT.MLS = 0;
	while(ICCR2.BIT.BBSY != 0);	/*oX܂ő҂*/
	ICCR1.BIT.TRS = 1;		/*}X^[M[h*/
	ICCR1.BIT.MST = 1;

	asm("MOV.B	#080H,00B9H");	/*BBSY=1,SCP=0  X^[gRfV*/
	
	/*1st byte*/
	w = iic_write(0xa0 + ((eepromaddress & 0x0700) >> 7));/*foCXAhX,write,ʃAhX*/
	if(w == 0){
	/*2nd byte*/
		w = iic_write((eepromaddress & 0x00ff));	/*ʃAhX*/
	}
	/*3rd byte*/
	for(m=0; m < num ;m++){					/*page writep[v*/
		if(w == 0){
			iic_write(writedata[m]);		/*݃f[^iic_writeɓ]*/
		}
	}
	ICSR.BIT.TEND = 0;
	ICSR.BIT.STOP = 0;
	asm("MOV.B	#00H,00B9H");	/*BBSY=0,SCP=0  XgbvRfV*/
	while(ICSR.BIT.STOP != 1);
	ICCR1.BIT.TRS = 0;		/*X[uM[h*/
	ICCR1.BIT.MST = 0;
	ICSR.BIT.TDRE = 0;
}


unsigned char iic_write(unsigned char writedata){	
	while(ICSR.BIT.TDRE == 0);		/*TDRE=1 Mf[^GveB܂ő҂*/
	ICDRT.BYTE = writedata;			/*Mf[^*/
	while(ICSR.BIT.TEND == 0);		/*TEND=1 M܂ő҂*/
	if((ICIER.BIT.ACKBR) != 0 ){		/*ACKAĂȂ */
		return(1);
	}
	return(0);
}


unsigned char byte_read(unsigned int eepromaddress){
	unsigned char readdata,r;
	while(ICCR2.BIT.BBSY != 0);		/*oX܂ő҂*/
	ICCR1.BIT.TRS = 1;			/*}X^[M[h*/
	ICCR1.BIT.MST = 1;
	asm("MOV.B	#080H,00B9H");		/*BBSY=1,SCP=0  X^[gRfV*/
	
	/*1st byte*/
	r = (iic_write(0xa0 + ((eepromaddress & 0x0700) >> 7 )));/*foCXAhX,write,ʃAhX*/
	if(r == 0){
	/*2nd byte*/
		r = iic_write((eepromaddress & 0x00ff));
	}
	asm("MOV.B	#080H,00B9H");		/*BBSY=1,SCP=0  X^[gRfV*/
	
	/*3rd byte*/
	r = (iic_write(0xa1));				/* foCXAhX,read,ʃAhX*/

	ICCR1.BIT.TRS = 0;
	
	ICIER.BIT.ACKBT = 1;				/*ACK=1iANmbWM*/
	
	readdata = ICDRR.BYTE;				/*_~[M*/
	while(ICSR.BIT.RDRF == 0);			/*RDRF MI܂ő҂*/

	readdata = ICDRR.BYTE;				/*f[^M*/
	while(ICSR.BIT.RDRF == 0);			/*RDRF MI܂ő҂*/
	
	asm("MOV.B	#00H,00B9H");			/*BBSY=0,SCP=0  XgbvRfV*/
	return(readdata);
}	


/*********************************** interrupts functions ***********************************/
#pragma INTERRUPT int0_func
void int0_func(void){
	if(SW3 == 0){			/*SW3ꂽ*/
		flag = 3;
	}
}
#pragma INTERRUPT int1_func
void int1_func(void){			
	if(SW2 == 0){			/*SW2ꂽ*/
		flag = 2;
	}
}


#pragma INTERRUPT rx_str0
void rx_str0(void){
	;	/*dummy*/
}

/* ^C}[֐ ///////////////////////////////////////////////////////////*/
/*********************************** timer functions ***********************************/
/*^C}[ݒ*/
void RD_init(void){
	TRDMR.BYTE = 0x00;		/*TRDGRC/DWX^WFlWX^ƂĎgp*/
	TRDFCR.BIT.PWM3 = 1;
	TRDFCR.BIT.CMD0 = 0;
	TRDFCR.BIT.CMD1 = 0;
	
	/*chanel1*/			/*AEgvbgRyA,^C}[荞*/
	TRDCR1.BYTE = 0x24;		/*TRDGRA1ŃRyAv,f32*/
	TRDPMR.BIT.PWMB1 = 0;		/*^C}[[h*/
	TRDIER1.BYTE = 0x01;		/*IMIA*/
	TRDIORA1.BYTE = 0x08;		/*RyAvŏo͋֎~*/
	TRDGRA1.WORD = 0x0270;		/*1msec*/
}


void wait_timer(const long msec2){
	asm("FCLR	I");		/*֎~,I=0*/
	asm("MOV.B	#01H,0049H");	/*TRD1IC register(wait_timer),level1*/
	asm("FSET	I");		/*,I=1*/
	msec = msec2;
	asm("OR.B	#0AH,0137H");	/*JEgJn*/
	while(msec != 0);
	asm("AND.B	#0DH,0137H");	/*JEg~*/
}



/**/
#pragma INTERRUPT timer_interrupt
void timer_interrupt(void){
	if(msec != 0){
		msec = (msec-1);
	}
	TRDSR1.BIT.IMFA = 0;		/*̊֐݂̂Őݒ*/
}



/*ԑ҂[v*/
void wait(const long sec){
	volatile long k;
	for(k=0; k<200*sec; k++);
}

/* LCD֐ ///////////////////////////////////////////////////////////*/
/*********************************** LCD functions ***********************************/
/*LCD*/
int LCD_init(void){
	wait(20);
	RS = 0;
	/*LCD1*/
	E = 1;
	DB4 = 1;		/*MM1*/
	DB5 = 1;
	DB6 = 0;
	DB7 = 0;
	wait(1);
	E = 0;
	wait(1);
	wait(5);
	
	/*LCD2*/
	E = 1;
	DB4 = 1;		/*MM2*/
	DB5 = 1;
	DB6 = 0;
	DB7 = 0;
	wait(1);
	E = 0;
	wait(1);

	/*LCD3*/
	E = 1;
	DB4 = 1;		/*MM3*/
	DB5 = 1;
	DB6 = 0;
	DB7 = 0;
	wait(1);
	E = 0;
	wait(1);
	
	/*LCD4*/
	E = 1;
	DB4 = 0;		/*MM4*/
	DB5 = 1;
	DB6 = 0;
	DB7 = 0;
	wait(1);
	E = 0;
	wait(1);
	
	LCD_clear();
	
	/*t@NVZbg  4bit(DL=0),2s(N=0),5x7tHg(F=0)*/
	LCD_write(0x28/*0x20 + 0x08*/);

	/*Gg[[h  \VtgȂ(S=0),CNg(I/O=1)*/
	LCD_write(0x06/*0x04 + 0x02*/);

	/*J[\/\Vtg  J[\ړ(S/C=0),Vtg(R/L=0)*/
	LCD_write(0x10);

	/*\ON/OFFRg[  S\(D=1),J[\:ON(C=1),uN:ON(B=1)*/
	LCD_write(0x0D/*0x08 + 0x04 + 0x01*/);
	
	
	LCD_clear();
	wait(5);
	return 0;
}
/*\NA*/
int LCD_clear(void)
{
	RS = 0;
	LCD_write(0x01);
	wait(2);
	LCD_location(0,0);
	return 0;
}

/**/
int LCD_write(char lcddata)
{
	/*4bit*/
	E = 1;
	DB4 = (( lcddata >> 4 ) & 0x01);
	DB5 = (( lcddata >> 5 ) & 0x01);
	DB6 = (( lcddata >> 6 ) & 0x01);
	DB7 = (( lcddata >> 7 ) & 0x01);
	wait(1);
	E = 0;
	wait(1);
	/*4bit*/
	E = 1;
	DB4 = ( lcddata & 0x01);
	DB5 = (( lcddata >> 1 ) & 0x01);
	DB6 = (( lcddata >> 2 ) & 0x01);
	DB7 = (( lcddata >> 3 ) & 0x01);
	wait(1);
	E = 0;
	wait(1);
	return 0;
}

/*J[\ړ*/
int LCD_location(const unsigned char x,const unsigned char y){
	unsigned char addressdata;
	addressdata = ( (y * 0x40) + x );
	addressdata = (addressdata | 0x80);		/*DRAMAhXݒDB7͐M*/
	RS = 0;
	LCD_write(addressdata);
	wait(1);

	xcursor = x;					/*J[\ۑ*/
	ycursor = y;
	return 0;
}

/*\*/
int LCD_print(char far *lcdstr){
	unsigned char n=0,j;
	/* \[v */
	for(n=0; lcdstr[n] != '\0'; n++){
		/*`*/
		if((lcdstr[n] >= 0x20 && lcdstr[n] <= 0x7f) || (lcdstr[n] >= 0xa1 && lcdstr[n] <= 0xfd)){
			/*LCDR[h͈͓̔̏ꍇ*/
			/*`*/
			RS = 1;
			LCD_write(lcdstr[n]);
			wait(1);
				/*J[\ړ*/
				if(xcursor == (VAL_LCD_ROW - 1)){	/*16sI[o[ꍇ(15,0)1̂҂*/
					
					xcursor = 0;
					ycursor = (ycursor == 0 ? 1 : 0);	/*(0,1)珑*/
					LCD_location(xcursor,ycursor);
					for(j = 0; j < VAL_LCD_ROW; ++j){
						RS = 1;
						LCD_write(' ');
					}
					LCD_location(xcursor,ycursor);
				}
				else{					/*16sȓ̏ꍇ*/
					++xcursor;
					LCD_location(xcursor,ycursor);
				}
		}
		else if( lcdstr[n] == '\n' ){			/*sR[h̏ꍇ*/
			xcursor = 0;
			ycursor = (ycursor == 0 ? 1 : 0);	/*y0*/
			LCD_location(xcursor,ycursor);
			for(j=0; j < 16; ++j){
				RS = 1;
				LCD_write(' ');
			}
			LCD_location(xcursor,ycursor);
		}
		else {	/*LCDR[h͈̔͊Ȍꍇ*/
		/* if ( ( lcdstr[n] >= 0x21 && lcdstr[n] <= 0x7f ) || ( lcdstr[n] >= 0xa1 && lcdstr[n] <= 0xfd ) )*/
		}
	}
	return 0;
}


